/**
@license
Copyright (c) 2014 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
//import '@polymer/iron-icon/iron-icon.js';
import '@polymer/iron-iconset-svg/iron-iconset-svg.js';

import {html} from '@polymer/polymer/lib/utils/html-tag.js';

const template = html`<iron-iconset-svg name="my" size="24">
<svg><defs>
<g id="clock">
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.403057"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:0.71437502;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="m 8.2455751,10.305881 2.1379299,2.179857"
     id="path11944"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:0.42498347;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="m 14.304941,8.823834 -3.921436,3.661904"
     id="path11944-3"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
</g>
<g id="stopwatch">
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.403057"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:0.5715;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="m 11.396615,9.0373126 -0.78008,4.0075264"
     id="path11944-3"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:0.25625211;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 15.462382,9.0942293 10.616535,13.044839"
     id="path11944-3-8"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <rect
     style="opacity:0.84999994;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.42875004;stroke-linecap:square;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="rect12568"
     width="0.085987262"
     height="0.17197452"
     x="-6.6849661"
     y="5.4274735"
     rx="52.659916"
     ry="0.17197452" />
  <rect
     style="opacity:0.84999994;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.42875004;stroke-linecap:square;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="rect12570"
     width="2.3216562"
     height="1.8487262"
     x="9.2226772"
     y="2.3749256"
     rx="52.659916"
     ry="0.17197436" />
  <rect
     style="opacity:0.84999994;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.81739497;stroke-linecap:square;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="rect12570-8"
     width="1.6337581"
     height="0.85987264"
     x="15.441241"
     y="-7.6296668"
     rx="37.05698"
     ry="0.079988077"
     transform="rotate(45.112563)"
     inkscape:transform-center-x="-0.085987263"
     inkscape:transform-center-y="-0.38694269" />
</g>
<g id="target">
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.403057"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#906060;stroke-width:1.42875006;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 17.142873,4.789048 13.382581,8.616241"
     id="path11944-3"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.57447505;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378-8"
     cx="10.383505"
     cy="12.403057"
     rx="5.8035293"
     ry="5.8513212" />
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.42125005;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378-8-0"
     cx="10.383505"
     cy="12.403057"
     rx="4.2299395"
     ry="4.3166761" />
  <ellipse
     style="opacity:0.84999994;fill:#000000;fill-opacity:1;stroke:#000000;stroke-width:0.1989416;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378-8-0-2"
     cx="10.383505"
     cy="12.403057"
     rx="1.9976518"
     ry="2.0386145" />
  <path
     inkscape:connector-curvature="0"
     d="m 11.808663,10.889453 4.302543,-1.3240499 c 0.04546,-0.014025 0.07897,-0.051506 0.08739,-0.096854 0.0085,-0.045549 -0.0099,-0.091753 -0.04753,-0.1201562 l -4.047581,-3.053356 c -0.03765,-0.028404 -0.08834,-0.03418 -0.13169,-0.015122 -0.0192,0.00856 -0.03559,0.021354 -0.0481,0.037004 -0.01557,0.019549 -0.02511,0.043617 -0.02672,0.069342 l -0.254942,4.3774061 c -0.0024,0.0409 0.01594,0.08016 0.04932,0.105281 0.03331,0.02512 0.0771,0.03264 0.117212,0.02035 z"
     id="path11306"
     style="stroke-width:0.12627427;fill:#906060;fill-opacity:1" />
</g>
<g id="play">
  <path
     inkscape:connector-curvature="0"
     d="M 15.498631,12.029309 7.6399184,6.6095065 C 7.5567244,6.5523276 7.4488704,6.5463658 7.3599856,6.5927052 7.2708299,6.6395864 7.2150059,6.731723 7.2150059,6.8325313 V 17.672136 c 0,0.100808 0.055824,0.193216 0.1449797,0.240097 0.039565,0.02059 0.082923,0.03089 0.1260104,0.03089 0.053927,0 0.1075831,-0.01626 0.1539224,-0.04797 l 7.8587126,-5.419798 c 0.07344,-0.05068 0.117068,-0.133869 0.117068,-0.223025 0,-0.08916 -0.0439,-0.17235 -0.117068,-0.223025 z"
     id="path11306"
     style="stroke-width:0.2709901" />
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.585464"
     rx="7.5118089"
     ry="7.649776" />
</g>
<g id="pause">
  <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.585464"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:3.28422022;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 7.8038852,9.4489695 V 15.721958"
     id="path11944"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:3.28422022;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 12.533186,9.4489695 V 15.721958"
     id="path11944-2"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
</g>
<g id="plus">
 <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.585464"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:3.28422022;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 13.519999,12.585464 H 7.2470109"
     id="path11944"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:3.28422022;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 10.383505,9.4489693 V 15.721958"
     id="path11944-2"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
</g>
<g id="minus">
 <ellipse
     style="opacity:0.84999994;fill:none;fill-opacity:0.55612242;stroke:#000000;stroke-width:0.74729973;stroke-linecap:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;paint-order:markers fill stroke"
     id="path11378"
     cx="10.383505"
     cy="12.585464"
     rx="7.5118089"
     ry="7.649776" />
  <path
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:3.28422022;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     d="M 13.519999,12.585464 H 7.2470109"
     id="path11944"
     inkscape:connector-type="polyline"
     inkscape:connector-curvature="0" />
</g>
<g
   id="digit"
   inkscape:label="">
  <desc
     id="desc13879">digit</desc>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="2"
     d="M 15.798207,3.4043353 H 6.925759"
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918537;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13837">2</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="8"
     d="M 14.845707,12.318198 H 5.9732587"
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918525;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13841">8</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="32"
     d="M 13.893207,21.232062 H 5.0207591"
     style="fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918525;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13845">32</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="1"
     d="m 14.845707,12.318198 0.9525,-8.9138627"
     style="display:inline;fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918513;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13835">1</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="4"
     d="m 5.9732587,12.318198 0.9525,-8.913863"
     style="display:inline;fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918501;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13839">4</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="16"
     d="m 13.893207,21.232061 0.9525,-8.913863"
     style="display:inline;fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918501;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13843">16</desc>
  </path>
  <path
     inkscape:connector-curvature="0"
     inkscape:connector-type="polyline"
     id="64"
     d="m 5.0207587,21.232061 0.9525,-8.913863"
     style="display:inline;fill:none;fill-rule:evenodd;stroke:#000000;stroke-width:1.69918501;stroke-linecap:round;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
     inkscape:label="">
    <desc
       id="desc13847">64</desc>
  </path>
</g>
<g
     id="question"
     onclick="ClickQuestion"
     inkscape:label="">
    <path
       inkscape:connector-curvature="0"
       style="fill:none;fill-opacity:0;stroke:#000000;stroke-width:0.2;stroke-linecap:round"
       d="m 9.87642,15.9254 c -0.07813,-0.2344 -0.07813,-0.4688 0,-0.7032 -0.07813,-0.7812 0.07812,-1.5625 0.39058,-2.2656 0.0782,-0.4687 0.3907,-0.9375 0.8594,-1.4844 0.3125,-0.3125 0.8594,-0.8593 1.6406,-1.64058 0.7813,-0.625 1.25,-1.17188 1.5625,-1.64063 0.1563,-0.3125 0.3125,-0.78125 0.3907,-1.40625 -0.0782,-0.78125 -0.4688,-1.5625 -1.0938,-2.34375 -0.7812,-0.625 -1.5625,-1.01562 -2.5,-1.01562 -1.0156,0 -1.87498,0.3125 -2.49998,0.9375 -0.70313,0.625 -1.09375,1.64062 -1.25,2.89062 L 5.03267,6.94099 C 5.18892,5.22224 5.81392,3.89412 6.90767,2.95662 7.92329,2.01912 9.25142,1.55037 11.0483,1.55037 c 1.7187,0 3.2031,0.54687 4.375,1.48437 1.0156,1.09375 1.5625,2.26563 1.6406,3.59375 -0.0781,0.85938 -0.3125,1.64063 -0.625,2.26563 -0.4687,0.78125 -1.1719,1.56248 -2.1875,2.49998 -0.8594,0.7031 -1.3281,1.25 -1.4844,1.4844 -0.2343,0.3906 -0.4687,0.7031 -0.5468,1.0937 -0.1563,0.4688 -0.1563,1.1719 -0.1563,1.9532 H 9.87642"
       id="path3745" />
    <path
       inkscape:connector-curvature="0"
       style="fill:none;fill-opacity:0;stroke:#000000;stroke-width:0.2;stroke-linecap:round"
       d="m 9.72017,20.5347 v -2.5781 h 2.65623 v 2.5781 H 9.72017"
       id="path3747" />
    <path
       inkscape:connector-curvature="0"
       id="path4572"
       d="m 9.9781505,19.306768 v -1.117834 h 1.1178345 1.117834 v 1.117834 1.117835 H 11.095985 9.9781505 Z"
       style="fillx:#ff5555;stroke-width:0.17197452" />
    <path
       inkscape:connector-curvature="0"
       id="path4574"
       d="M 10.024751,14.863549 C 10.222526,12.947286 10.436455,12.568992 12.583195,10.33942 14.286823,8.5700565 14.617829,8.136608 14.750136,7.5018401 15.067097,5.9811529 14.185078,4.3485688 12.663882,3.6402607 10.337167,2.5568826 7.8799602,3.8580671 7.3152839,6.4725472 7.1908207,7.0488164 7.1853243,7.0516891 6.4104213,6.9454768 5.9816196,6.8867032 5.5324811,6.8386158 5.4123352,6.8386158 c -0.1758663,0 -0.1770122,-0.175991 -0.00588,-0.9028666 C 5.6918934,4.7233613 6.0258647,4.1361301 6.9118078,3.288845 7.8662894,2.3760116 8.4513502,2.0896408 9.8646077,1.8435326 12.123533,1.4501577 14.723587,2.3206931 15.810604,3.8343379 c 1.050506,1.4628032 1.259778,2.6395028 0.752529,4.2313441 -0.245332,0.7699 -0.597555,1.2357406 -2.127923,2.814335 -2.047457,2.111976 -2.379715,2.636494 -2.517837,3.974764 l -0.09562,0.926509 h -0.94586 -0.9458598 z"
       style="fillx:#ff5555;stroke-width:0.17197452" />
  </g>
</defs></svg>
</iron-iconset-svg>`;

document.head.appendChild(template.content);
