/* mergeIntoJSON.svelte generated by Svelte v3.12.1 */
import {
	SvelteElement,
	flush,
	init,
	insert,
	noop,
	safe_not_equal
} from "./svelte/internal.js";
import { createEventDispatcher } from "./svelte/svelte.js";

function create_fragment(ctx) {
	return {
		c() {
			this.c = noop;
		},

		m: noop,
		p: noop,
		i: noop,
		o: noop,
		d: noop
	};
}

function instance($$self, $$props, $$invalidate) {
	const dispatch = createEventDispatcher();

    let { json = {}, data = {} } = $$props;

    function merge(jsonIn, dataIn) {
        jsonIn = jsonIn || json;
        dataIn = dataIn || data;
        var jsonString = JSON.stringify(jsonIn);
        for (var prop in dataIn) {
            var value = dataIn[prop];
            var subKey = "${" + prop + "}";
            while (jsonString.indexOf(subKey) >= 0) {
                jsonString = jsonString.replace(subKey, value);
            }
        }
        var merged = JSON.parse(jsonString);
        event("merged", merged);
        return merged;
    }

	function event(eventName, payload) {
        dispatch(eventName, payload);
	}

	$$self.$set = $$props => {
		if ('json' in $$props) $$invalidate('json', json = $$props.json);
		if ('data' in $$props) $$invalidate('data', data = $$props.data);
	};

	$$self.$$.update = ($$dirty = { json: 1, data: 1 }) => {
		if ($$dirty.json) { if (json) {
                if (json.split) {
                    $$invalidate('json', json = JSON.parse(json));
                }
                merge();
        	} }
		if ($$dirty.data) { if (data) {
                if (data.split) {
                    $$invalidate('data', data = JSON.parse(data));
                }
                merge();
        	} }
	};

	return { json, data, merge };
}

class mergeIntoJSON extends SvelteElement {
	constructor(options) {
		super();

		init(this, { target: this.shadowRoot }, instance, create_fragment, safe_not_equal, ["json", "data", "merge"]);

		if (options) {
			if (options.target) {
				insert(options.target, this, options.anchor);
			}

			if (options.props) {
				this.$set(options.props);
				flush();
			}
		}
	}

	static get observedAttributes() {
		return ["json","data","merge"];
	}

	get json() {
		return this.$$.ctx.json;
	}

	set json(json) {
		this.$set({ json });
		flush();
	}

	get data() {
		return this.$$.ctx.data;
	}

	set data(data) {
		this.$set({ data });
		flush();
	}

	get merge() {
		return this.$$.ctx.merge;
	}
}

export {mergeIntoJSON};
window.customElements.define('merge-into-json', mergeIntoJSON);
